/////////////////////////////////////////////////////////////////////////////////////////////////////////
//   _     ____ ____    _   _  ___  _  _____    _      __________ _  ___  
//  | |   / ___|  _ \  | \ | |/ _ \| |/ /_ _|  / \    |___ /___ // |/ _ \ 
//  | |  | |   | | | | |  \| | | | | ' / | |  / _ \     |_ \ |_ \| | | | |
//  | |__| |___| |_| | | |\  | |_| | . \ | | / ___ \   ___) |__) | | |_| |
//  |_____\____|____/  |_| \_|\___/|_|\_\___/_/   \_\ |____/____/|_|\___/ 
//
//  ALL YOU NEED TO DO GRAPHICS WITH A NOKIA3310 LCD SCREEN AND AN ARDUINO
//
//						CODED BY FRASER ASHWORTH 2009
/////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef LCD_NOKIA_3310_H
#define LCD_NOKIA_3310_H

#ifdef PB1
#define LCD_DC  PB0
#define LCD_RST PB1
#define SPI_CS  PB2
#define SPI_MOSI PB3
#define SPI_SCK PB5
#define LCD_BL  PD7
#else 
#define LCD_DC  PORTB0
#define LCD_RST PORTB1
#define SPI_CS  PORTB2
#define SPI_MOSI PORTB3
#define SPI_SCK PORTB5
#define LCD_BL  PORTD7
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//CLASS DEFINITION
class LCD_Nokia_3310
	{
	public:
		LCD_Nokia_3310();
		void Initialise(void);
		void BackLight(bool bOn);
		
		void ClearBuffer(void);
		void RenderBuffer(void);
		
		void Pixel(int x, int y, bool bInvert);
		void Line(int x0, int y0, int x1, int y1, bool bInvert);
		void Rectangle(int x0, int y0, int x1, int y1, bool bInvert);
		void Box(int x0, int y0, int x1, int y1, bool bInvert);
		void Triangle(int x0, int y0, int x1, int y1, int x2, int y2, bool bInvert);
		void Bitmap(int x,int y, int w, int h, unsigned char* pBmp);
		void SmallChar(int x0, int y0, unsigned char ucChar, bool bInvert);
		void LargeDigit(int x0, int y0, int iDigit, bool bInvert);
		void SmallString(int x0, int y0, char* pStr, int iInvert);
		void SmallNumber(int x0, int y0, long lNumber, int iDigits, int iInvert);
		void LargeNumber(int x0, int y0, long lNumber, int iInvert);

		enum K
		{
			WIDTH = 84,
			HEIGHT = 48,
			PIXELS = WIDTH*HEIGHT,
			BYTES = PIXELS/8,
		};
		unsigned char pBuffer[WIDTH*HEIGHT/8];
		
	private:
		void SetXY(unsigned char x, unsigned char y);
		void WriteByte(unsigned char byte, bool bControl);
		char* ltoa(long, int);
	};
#endif
